
#include <bbtkInterpreter.h>
#include <bbtkConfigurationFile.h>

//==========================================================================
int main(int argc, char **argv)
{
  if (argc>1)
    {
      if (argv[1][1]=='q') 
	bbtk::MessageManager::SetMessageLevel("max",0);
      else if (argv[1][1]=='v')
	bbtk::MessageManager::SetMessageLevel("all",9);		 
      else 
	{
	  std::cout << "usage : bbRegenerateBoxesLists [-q|-v] (quiet or verbose)" << std::endl;
	  return 0;
	}
    }

  try
    {
      bbtk::Interpreter::Pointer I = bbtk::Interpreter::New();
      I->SetCommandLine(true);
      I->SetThrow(false);

      std::string doc_path = bbtk::ConfigurationFile::GetInstance().Get_doc_path();
      doc_path += bbtk::ConfigurationFile::GetInstance().Get_file_separator();
      doc_path += "bbdoc";
      doc_path += bbtk::ConfigurationFile::GetInstance().Get_file_separator();

      I->InterpretLine( "exec freeze_no_error");
      I->InterpretLine( "include *");
      I->GetExecuter()->GetFactory()->CreateHtmlIndex(bbtk::Factory::Initials, doc_path   + "index-alpha.html");
      I->GetExecuter()->GetFactory()->CreateHtmlIndex(bbtk::Factory::Packages, doc_path   + "index-package.html");
      I->GetExecuter()->GetFactory()->CreateHtmlIndex(bbtk::Factory::Categories, doc_path + "index-category.html");
      I->GetExecuter()->GetFactory()->CreateHtmlIndex(bbtk::Factory::Adaptors, doc_path   + "index-adaptors.html");

    }
  catch (bbtk::Exception e)
    {
      std::cout << "* ERROR : "<<e.GetErrorMessage()<<std::endl;
      return 1;
    }
  return 0;
}
//==========================================================================


