#ifdef _USE_VTK_

#ifndef __bbgdcmvtkGetInfoGdcmReader_h_INCLUDED__
#define __bbgdcmvtkGetInfoGdcmReader_h_INCLUDED__

#include "bbgdcmvtk_EXPORT.h"
#include "bbtkAtomicBlackBox.h"
#include "iostream"

#include "vtkGdcmReader.h"

namespace bbgdcmvtk
{

class bbgdcmvtk_EXPORT GetInfoGdcmReader
 : 
   public bbtk::AtomicBlackBox
{
  BBTK_BLACK_BOX_INTERFACE(GetInfoGdcmReader,bbtk::AtomicBlackBox);

  BBTK_DECLARE_INPUT(In,            std::string);
  BBTK_DECLARE_OUTPUT(Out,          vtkImageData *);
  BBTK_DECLARE_OUTPUT(IPP,          std::vector<double>);
  BBTK_DECLARE_OUTPUT(IOP,          std::vector<double>);
  BBTK_DECLARE_OUTPUT(PixelSpacing, std::vector<double>);
  BBTK_DECLARE_OUTPUT(InterSlice,   double);
       
  BBTK_PROCESS(Process);
  void Process();
  
  private:
     GDCM_NAME_SPACE::File *f;
     vtkGdcmReader *reader;
};

  //=================================================================
  // UserBlackBox description
BBTK_BEGIN_DESCRIBE_BLACK_BOX(GetInfoGdcmReader,bbtk::AtomicBlackBox);
BBTK_NAME("GetInfoGdcmReader");
BBTK_AUTHOR("jpr, eduardo");
BBTK_DESCRIPTION("Get Dicom info (for a single File) and read (as a vtkImageData)");
BBTK_CATEGORY("");

BBTK_INPUT(GetInfoGdcmReader,In,           "Dicom image file name",       std::string,"");

BBTK_OUTPUT(GetInfoGdcmReader,Out,         "Output image",                vtkImageData *,"");
BBTK_OUTPUT(GetInfoGdcmReader,IPP,         "Image Position (Patient)",    std::vector<double>,"");
BBTK_OUTPUT(GetInfoGdcmReader,IOP,         "Image Orientation (Patient)", std::vector<double>,"");
BBTK_OUTPUT(GetInfoGdcmReader,PixelSpacing,"Pixel Spacing",               std::vector<double>,"");
BBTK_OUTPUT(GetInfoGdcmReader,InterSlice,  "InterSlice",                  double,"");
BBTK_END_DESCRIBE_BLACK_BOX(GetInfoGdcmReader);
} // EO namespace bbgdcmvtk

#endif // __bbgdcmvtkGetInfoGdcmReader_h_INCLUDED__

#endif //_USE_VTK_
