#ifdef USE_KWWIDGETS

#ifndef __vtkKWSlicer_h
#define __vtkKWSlicer_h


#include "vtkKWCompositeWidget.h"

class vtkImageData;
class vtkKWRenderWidget;
class vtkImageViewer2;
class vtkKWScale;
class vtkKWWindowLevelPresetSelector;
class vtkKWSimpleAnimationWidget;
class vtkKWMenu;
class vtkKWSplitFrame;
class vtkKWCornerAnnotationEditor;
//namespace bbkw {

class vtkKWSlicer : public vtkKWCompositeWidget
{
public:
  static vtkKWSlicer* New();
  vtkTypeRevisionMacro(vtkKWSlicer,vtkKWCompositeWidget);

  void SetImage(vtkImageData*);
  void UpdateImage();

  // Description:
  // Callbacks
  virtual void SetSliceFromScaleCallback(double value);
  virtual void SetSliceCallback(int slice);
  virtual int  GetSliceCallback();
  virtual int  GetSliceMinCallback();
  virtual int  GetSliceMaxCallback();
  virtual void SetSliceOrientationToXYCallback();
  virtual void SetSliceOrientationToXZCallback();
  virtual void SetSliceOrientationToYZCallback();
  virtual void WindowLevelPresetApplyCallback(int id);
  virtual int  WindowLevelPresetAddCallback();
  virtual void WindowLevelPresetUpdateCallback(int id);
  virtual void WindowLevelPresetHasChangedCallback(int id);

  void ProcessCallbackCommandEvents(vtkObject *caller, 
				    unsigned long event, 
				    void *calldata);
protected:
  vtkKWSlicer();
  ~vtkKWSlicer();

  // Description:
  // Create the widget.
  virtual void CreateWidget();
  vtkKWSplitFrame                     *Frame;
  vtkImageData                   *Image;
  vtkImageViewer2                *ImageViewer; 
  vtkKWScale                     *SliceScale;
  vtkKWWindowLevelPresetSelector *WindowLevelPresetSelector;
  vtkKWRenderWidget              *RenderWidget;
  vtkKWSimpleAnimationWidget     *AnimationWidget;
  vtkKWMenu                      *OrientationMenu;
  vtkKWCornerAnnotationEditor    *AnnotationEditor;

  virtual void UpdateSliceRanges();

private:
  vtkKWSlicer(const vtkKWSlicer&);   // Not implemented.
  void operator=(const vtkKWSlicer&);  // Not implemented.
};

//}
#endif
#endif
