#include "bbvtkVecImageGaussianSmooth.h"
#include "bbvtkPackage.h"

#include "vtkImageGaussianSmooth.h"


namespace bbvtk
{

BBTK_ADD_BLACK_BOX_TO_PACKAGE(vtk,VecImageGaussianSmooth)
BBTK_BLACK_BOX_IMPLEMENTATION(VecImageGaussianSmooth,bbtk::AtomicBlackBox);

	
	
	//---------------------------------------------------------------------
	void VecImageGaussianSmooth::bbUserSetDefaultValues()
	{
		bbSetInputStdDevX(2); 
		bbSetInputStdDevY(2); 
		bbSetInputStdDevZ(2);  
		bbSetInputiImage(0);
	}
	
	void VecImageGaussianSmooth::bbUserInitializeProcessing()
	{
	}
	
	//---------------------------------------------------------------------
	void VecImageGaussianSmooth::bbUserFinalizeProcessing()
	{ 
		int i,size = (int)VecVtkimagegaussiansmooth.size();
		for (i=0 ;  i<size ; i++)
		{		
			VecVtkimagegaussiansmooth[i]->Delete();
		}
		VecVtkimagegaussiansmooth.clear();
	}
	
	
	
	//---------------------------------------------------------------------
	
	void VecImageGaussianSmooth::Process()
	{
		bbUserFinalizeProcessing();
		
		vtkImageGaussianSmooth *vtkimagegaussiansmooth;
		VecResult.clear();

		double stdvX=bbGetInputStdDevX();
		double stdvY=bbGetInputStdDevY();
		double stdvZ=bbGetInputStdDevZ();
		
		int i,size=(int)bbGetInputIn().size();
		for (i=0 ;  i<size ; i++)
		{	
			vtkimagegaussiansmooth = vtkImageGaussianSmooth::New();
			vtkimagegaussiansmooth->SetInput( bbGetInputIn()[i] );
			vtkimagegaussiansmooth->SetStandardDeviation( stdvX,stdvY, stdvZ ); 
			vtkimagegaussiansmooth->Update();
			VecResult.push_back( vtkimagegaussiansmooth->GetOutput() );
			VecVtkimagegaussiansmooth.push_back(vtkimagegaussiansmooth);
		} //for i
		
		bbSetOutputOut(VecResult);
		if (bbGetInputiImage() < (int)VecResult.size())
		{
			bbSetOutputOutImage(VecResult[bbGetInputiImage()]);
		} //if
		
	}


}
// EO namespace bbvtk


