/*=========================================================================                                                                               
  Program:   bbtk
  Module:    $RCSfile: bbwxColourSelector.h,v $
  Language:  C++
  Date:      $Date: 2009/05/15 14:58:03 $
  Version:   $Revision: 1.9 $
=========================================================================*/

/* ---------------------------------------------------------------------

* Copyright (c) CREATIS-LRMN (Centre de Recherche en Imagerie Medicale)
* Authors : Eduardo Davila, Laurent Guigues, Jean-Pierre Roux
*
*  This software is governed by the CeCILL-B license under French law and 
*  abiding by the rules of distribution of free software. You can  use, 
*  modify and/ or redistribute the software under the terms of the CeCILL-B 
*  license as circulated by CEA, CNRS and INRIA at the following URL 
*  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html 
*  or in the file LICENSE.txt.
*
*  As a counterpart to the access to the source code and  rights to copy,
*  modify and redistribute granted by the license, users are provided only
*  with a limited warranty  and the software's author,  the holder of the
*  economic rights,  and the successive licensors  have only  limited
*  liability. 
*
*  The fact that you are presently reading this means that you have had
*  knowledge of the CeCILL-B license and that you accept its terms.
* ------------------------------------------------------------------------ */                                                                         


/**
 * \file 
 * \brief Short description in one line
 * 
 * Long description which 
 * can span multiple lines
*/

/**
 * \class bbwx::ColorDialog
 * \brief 

 */

#ifdef _USE_WXWIDGETS_

// Prevents multiple inclusions : use symbols of the form
// __FILENAME_INCLUDED__ 
// where FILENAME must be replaced by the actual file name
#ifndef __bbWxColourSelector_h__
#define __bbWxColourSelector_h__

// Include base BlackBox definition
#include "bbtkAtomicBlackBox.h"
// Include bbwx_EXPORT symbol definition
#include "bbwx_EXPORT.h"

// Namespace of the package "wx" is "bbwx" 
// Namespace associated to packages should be of the form :
// bbPACKAGENAME
namespace bbwx
{

  //=================================================================
  class bbwx_EXPORT ColourSelector : public bbtk::AtomicBlackBox
  {
    BBTK_BLACK_BOX_INTERFACE(ColourSelector,bbtk::AtomicBlackBox);
    BBTK_DECLARE_OUTPUT(Out,std::string);
    BBTK_PROCESS(Process);
    void Process();
  protected:
	  
  };
  
  //=================================================================
  // UserBlackBox description
  BBTK_BEGIN_DESCRIBE_BLACK_BOX(ColourSelector,bbtk::AtomicBlackBox);
  BBTK_CATEGORY("widget");
  BBTK_NAME("ColourSelector");
  BBTK_AUTHOR("laurent.guigues@creatis.insa-lyon.fr");
  BBTK_DESCRIPTION("Colour Selector dialog (bbfication of wxColourSelector)");
  BBTK_OUTPUT(ColourSelector,Out,"Colour choosen in format '[0,1] [0,1] [0,1]'",std::string,"colour");
  BBTK_END_DESCRIBE_BLACK_BOX(ColourSelector);
  //=================================================================

}//namespace bbtk

#endif  // __bbtkWxColourSelector_h__
#endif //USE_WXWIDGETS
